#!/usr/bin/env node
// Copyright IBM Corp. 2016. All Rights Reserved.
// Node module: apiconnect-cli-policies
// US Government Users Restricted Rights - Use, duplication or disclosure
// restricted by GSA ADP Schedule Contract with IBM Corp.

/********************************************************* {COPYRIGHT-TOP} ***
 * IBM Confidential
 * OCO Source Materials
 * 5725-C11, 5725-C12, 7198-8FX, 5725-F70, 5725-F71, 5725-F72, 5725-L30
 *
 * (C) Copyright IBM Corporation 2015  All Rights Reserved.
 *
 * The source code for this program is not published or otherwise
 * divested of its trade secrets, irrespective of what has been
 * deposited with the U.S. Copyright Office.
 ********************************************************* {COPYRIGHT-END} **/

var subscriptions = require('apiconnect-apim-client').subscriptions;
var listFormat = require('./formatter').listFormat;
var getFormat = require('./formatter').getFormat;

module.exports.list = list;
function list(options) {
  if (!options.scope) {
    // default to org
    options.scope = 'catalog';
  }

  return subscriptions.list(options).then(function(result) {
    listFormat(result, options);
  });
}

module.exports.get = get;
function get(name, options) {
  if (!options.scope) {
    // default to org
    options.scope = 'catalog';
  }

  options.name = name;
  return subscriptions.get(options).then(function(result) {
    getFormat(result, options);
  });
}
